#
# This file is licensed under the GNU General Public License, Version 2.
#
#
# Default Ruby environment preparation script for Schmant builds.
#

#
# FUNCTIONS THAT SCRIPTS CAN USE
#
 
def debug(s)
	Schmant::ReportManager.report.debug s != nil ? s : "<nil>"
end

def info(s)
	Schmant::ReportManager.report.info s != nil ? s : "<nil>"
end

def warn(s)
	Schmant::ReportManager.report.warn s != nil ? s : "<nil>"
end

def error(s)
	Schmant::ReportManager.report.error s != nil ? s : "<nil>"
end

def fail(s)
	Schmant::ReportManager.report.error s != nil ? s : "<nil>"
	raise Schmant::SchmantException(s != nil ? s : "<nil>")
end

#
# Enable the task package and import all its packages.
#
def enableTaskPackage(name)
	Schmant.enableTaskPackage name
end

#
# START HERE
#

# Import dependencies
# NB: When modifying this list, update the JRuby documentation too

require 'java'

module Schmant
	include_package "org.entityfs"
	include_package "org.entityfs.el"
	include_package "org.entityfs.entityattrs.unix"
	include_package "org.entityfs.fs"
	include_package "org.entityfs.lock"
	include_package "org.entityfs.ostrat"
	include_package "org.entityfs.support.util"
	include_package "org.entityfs.support.util.regexp"
	include_package "org.entityfs.util"
	include_package "org.entityfs.util.cap.entity"
	include_package "org.entityfs.util.filter"
	include_package "org.entityfs.util.filter.entity"
	include_package "org.entityfs.util.filter.regexp"
	include_package "org.entityfs.util.itr"
	include_package "org.entityfs.util.properties"
	include_package "org.entityfs.util.zip"

	include_package "org.schmant"
	include_package "org.schmant.arg"
	include_package "org.schmant.lang"
	include_package "org.schmant.project"
	include_package "org.schmant.project.eclipse"
	include_package "org.schmant.project.filter"
	include_package "org.schmant.project.intellij"
	include_package "org.schmant.project.java"
	include_package "org.schmant.report"
	include_package "org.schmant.run"
	include_package "org.schmant.support"
	include_package "org.schmant.support.entityfs"
	include_package "org.schmant.support.io"
	include_package "org.schmant.support.text"
	include_package "org.schmant.support.xml"
	include_package "org.schmant.task"
	include_package "org.schmant.task.template.jdk.javadoc"
	include_package "org.schmant.tpm"
	
	def Schmant.enableTaskPackage(name)
		debug "Enabling task package " + name
		tp = Schmant::TaskPackageManager::get.getTaskPackage(name)
		tp.enable
		tp.javaPackageNames.each do |packageName|
			debug "Importing Java package " + packageName + " in the Schmant module"
			include_package packageName
		end
	end
end

debug "In prepare.rb"

enableTaskPackage "org.schmant.task.base"
